Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
Botan::ProcWalking_EntropySource Class Referencefinal

`#include <proc_walk.h>`

Inheritance diagram for Botan::ProcWalking_EntropySource:

## Public Member Functions
std::string | name () const override
size_t | poll (RandomNumberGenerator &rng) override
| ProcWalking_EntropySource (const std::string &root_dir)

## Static Public Member Functions
static std::unique_ptr< Entropy_Source > | create (const std::string &type)

## Detailed Description

File Tree Walking Entropy Source

Definition at line 26 of file proc_walk.h.

## Constructor & Destructor Documentation

Botan::ProcWalking_EntropySource::ProcWalking_EntropySource | ( | const std::string & | root_dir | ) |
| inline explicit

Definition at line 33 of file proc_walk.h.

33 :
34 m_path(root_dir), m_dir(nullptr) {}

## Member Function Documentation

std::unique_ptr< Entropy_Source > Botan::Entropy_Source::create | ( | const std::string & | type | ) |
| static inherited

Return a new entropy source of a particular type, or null Each entropy source may require substantial resources (eg, a file handle or socket instance), so try to share them among multiple RNGs, or just use the preconfigured global list accessed by Entropy_Sources::global_sources()

Definition at line 67 of file entropy_srcs.cpp.

References BOTAN_UNUSED, and Botan::OS::running_in_privileged_state().

Referenced by Botan::Entropy_Sources::Entropy_Sources().

68 {
69 #if defined(BOTAN_HAS_SYSTEM_RNG)
70 if(name == "system_rng" || name == "win32_cryptoapi")
71 {
72 return std::unique_ptr<Entropy_Source>(new System_RNG_EntropySource);
73 }
74 #endif
75
76 #if defined(BOTAN_HAS_ENTROPY_SRC_RDRAND)
77 if(name == "rdrand")
78 {
79 return std::unique_ptr<Entropy_Source>(new Intel_Rdrand);
80 }
81 #endif
82
83 #if defined(BOTAN_HAS_ENTROPY_SRC_RDSEED)
84 if(name == "rdseed")
85 {
86 return std::unique_ptr<Entropy_Source>(new Intel_Rdseed);
87 }
88 #endif
89
90 #if defined(BOTAN_HAS_ENTROPY_SRC_DARN)
91 if(name == "p9_darn")
92 {
93 return std::unique_ptr<Entropy_Source>(new POWER9_DARN);
94 }
95 #endif
96
97 #if defined(BOTAN_HAS_ENTROPY_SRC_GETENTROPY)
98 if(name == "getentropy")
99 {
100 return std::unique_ptr<Entropy_Source>(new Getentropy);
101 }
102 #endif
103
104 #if defined(BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM)
105 if(name == "dev_random")
106 {
107 return std::unique_ptr<Entropy_Source>(new Device_EntropySource(BOTAN_SYSTEM_RNG_POLL_DEVICES));
108 }
109 #endif
110
111 #if defined(BOTAN_HAS_ENTROPY_SRC_PROC_WALKER)
112 if(name == "proc_walk" && OS::running_in_privileged_state() == false)
113 {
114 const std::string root_dir = BOTAN_ENTROPY_PROC_FS_PATH;
115 if(!root_dir.empty())
116 return std::unique_ptr<Entropy_Source>(new ProcWalking_EntropySource(root_dir));
117 }
118 #endif
119
120 #if defined(BOTAN_HAS_ENTROPY_SRC_WIN32)
121 if(name == "system_stats")
122 {
123 return std::unique_ptr<Entropy_Source>(new Win32_EntropySource);
124 }
125 #endif
126
127 BOTAN_UNUSED(name);
128 return std::unique_ptr<Entropy_Source>();
129 }
Botan::Entropy_Source::name
virtual std::string name() const =0
Botan::OS::running_in_privileged_state
bool running_in_privileged_state()
Definition: os_utils.cpp:143
BOTAN_UNUSED
#define BOTAN_UNUSED(...)
Definition: assert.h:142

std::string Botan::ProcWalking_EntropySource::name | ( |  | ) | const
| inline override virtual

Returns
  name identifying this entropy source

Implements Botan::Entropy_Source.

Definition at line 29 of file proc_walk.h.

29 { return "proc_walk"; }

size_t Botan::ProcWalking_EntropySource::poll | ( | RandomNumberGenerator & | rng | ) |
| override virtual

Perform an entropy gathering poll

Parameters

  rng | will be provided with entropy via calls to add_entropy

Returns
  conservative estimate of actual entropy added to rng during poll

Implements Botan::Entropy_Source.

Definition at line 112 of file proc_walk.cpp.

References Botan::RandomNumberGenerator::add_entropy(), and m_mutex.

113 {
114 const size_t MAX_FILES_READ_PER_POLL = 2048;
115
116 lock_guard_type<mutex_type> lock(m_mutex);
117
118 if(!m_dir)
119 m_dir.reset(new Directory_Walker(m_path));
120
121 m_buf.resize(4096);
122
123 size_t bits = 0;
124
125 for(size_t i = 0; i != MAX_FILES_READ_PER_POLL; ++i)
126 {
127 int fd = m_dir->next_fd();
128
129 // If we've exhaused this walk of the directory, halt the poll
130 if(fd == -1)
131 {
132 m_dir.reset();
133 break;
134 }
135
136 ssize_t got = ::read(fd, m_buf.data(), m_buf.size());
137 ::close(fd);
138
139 if(got > 0)
140 {
141 rng.add_entropy(m_buf.data(), static_cast<size_t>(got));
142
143 // Conservative estimate of 4 bits per file
144 bits += 4;
145 }
146
147 if(bits > 128)
148 break;
149 }
150
151 return bits;
152 }

The documentation for this class was generated from the following files:

- src/lib/entropy/proc_walk/proc_walk.h
- src/lib/entropy/proc_walk/proc_walk.cpp